Index: trunk/kernel/mm/kcm.h
===================================================================
--- trunk/kernel/mm/kcm.h	(revision 690)
+++ trunk/kernel/mm/kcm.h	(revision 1)
@@ -1,6 +1,7 @@
 /*
- * kcm.h - Kernel Cache Manager definition.
+ * kcm.h - Per-cluster Kernel Cache Manager Interface
  *
- * Authors    Alain Greiner (2016,2017,2018,2019,2020)
+ * Authors  Ghassan Almaless (2008,2009,2010,2011,2012)
+ *          Alain Greiner    (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -26,6 +27,6 @@
 
 #include <list.h>
-#include <hal_kernel_types.h>
-#include <busylock.h>
+#include <hal_types.h>
+#include <spinlock.h>
 #include <page.h>
 #include <bits.h>
@@ -33,41 +34,29 @@
 
 /****************************************************************************************
- * This structure defines a generic Kernel Cache Manager, a fixed size block allocator.
- * It returns an aligned block whose size is a power of 2, not smaller than a cache line,
- * but smaller than a small PPM page. It exists in each cluster a specific KCM allocator
- * for each possible block size. When the cache line contains 64 bytes and the page 
- * contains 4K bytes, the possible block sizes are 64, 128, 256, 512, 1024, 2048 bytes.
- * These KCM allocators are initialized by the cluster_init() function.
- *
- * Each KCM cache is implemented as a set of "kcm_pages": a "kcm_page" is an aligned
- * buffer in physical memory (allocated by the PPM allocator) such as :
- *       buffer_size = block_size * 64  <=>  buffer_order = block_order + 6.
- * 
- * A kcm_page contains always 64 kcm_blocks, but the first block (that cannot be smaller
- * than 64 bytes) is used to store the kcm_page descriptor defining the page allocation
- * status, and cannot be allocated to store data.
- *
- * A KCM cache is extensible, as new kcm_pages are dynamically allocated from the PPM
- * allocator when required. For a given KCM cache the set of kcm_pages is split in two
- * lists: the list of "full" pages (containing 63 allocated blocks), and the list of
- * "active" pages (containing at least one free block). An "empty" page (containing
- * only free blocks) is considered active, and is not released to PPM.
- * 
- * To allow any thread running in any cluster to directly access the KCM of any cluster,
- * ALMOS-MKH defines two sets of access functions, for local or remote access.
+ * This structure defines a generic Kernel Cache Manager, that is a block allocator,
+ * for fixed size objects. It exists a specific KCM allocator for each object type.
+ * The actual allocated block size is the smallest multiple of 64 bytes that can
+ * contain one single object.
+ * The various KCM allocators themselves are not statically allocated in the cluster
+ * manager, but are dynamically allocated when required, using the specific KCM 
+ * allocator defined in the cluster manager, to allocate the other ones...
  ***************************************************************************************/
 
-typedef struct kcm_s
+typedef struct kcm_s                      
 {
-	remote_busylock_t    lock;             /*! protect KCM allocator                   */
+	spinlock_t           lock;             /*! protect exclusive access to allocator   */
+	uint32_t             block_size;       /*! actual block size (bytes)               */
+	uint32_t             blocks_nr;        /*! number of blocks per page               */
 
-	list_entry_t         full_root;        /*! root of full pages list                 */
 	list_entry_t         active_root;      /*! root of active pages list               */
+	list_entry_t         busy_root;        /*! root of busy pages list                 */
+	list_entry_t         free_root;        /*! root of free pages list                 */
 
-	uint32_t             full_pages_nr;    /*! number of full pages                    */
+	uint32_t             free_pages_nr;    /*! number of free pages                    */
+	uint32_t             busy_pages_nr;    /*! number of busy pages                    */
 	uint32_t             active_pages_nr;  /*! number of active pages                  */
 
-	uint32_t             order;            /*! ln( block_size )                        */
-}
+    uint32_t             type;             /*! KCM type                                */
+} 
 kcm_t;
 
@@ -75,95 +64,61 @@
 /****************************************************************************************
  * This structure defines a KCM-page descriptor.
- * A KCM-page contains (CONFIG_PPM_PAGE_SIZE / block_size) slots. 
- * Each slot contains one block, but the kcm page descriptor is stored in first slot.
- * The current allocation status is defined by the 64 bits "status" bit vector: each
- * non zero bit defines an allocated block / "count" is the number of allocated blocks. 
- * Each kcm_page is registered in one of the two following lists, rooted in the kcm:
- * - full   : when count == max
- * - active : count < max 
+ * A KCM-page can contain several blocks.
+ * This descriptor is stored in the first block slot.
  ***************************************************************************************/
 
 typedef struct kcm_page_s
 {
-	uint64_t            status;            /*! bit vector: non-zero == allocated       */
-	uint32_t            count;             /*! number of allocated blocks in page      */
-	list_entry_t        list;              /*! [active / busy / free] list member      */
-	kcm_t             * kcm;               /*! pointer on kcm allocator                */
-	page_t            * page;              /*! pointer on physical page descriptor     */
-}
+	BITMAP          ( bitmap , 16 );       /*! at most 16 blocks in a page (1 if free) */
+	uint8_t       * blk_tbl;               /*! pointer on first free block in page     */
+	kcm_t         * kcm;                   /*! owner KCM allocator                     */
+	uint8_t         unused;                /*! first free block index in page          */
+	uint8_t         refcount;              /*! number of allocated blocks              */
+	uint8_t         busy;                  /*! page busy if non zero                   */
+	uint8_t         active;                /*! page active if non zero                 */
+	list_entry_t    list;                  /*! [active / busy / free] list member      */
+	page_t        * page;                  /*! pointer on the physical page descriptor */
+} 
 kcm_page_t;
 
 /****************************************************************************************
- * This function must be called by a local thread. 
- * It initializes a Kernel Cache Manager, depending on block size.
+ * This function initializes a generic Kernel Cache Manager. 
  ****************************************************************************************
- * @ kcm      : pointer on KCM to be initialized.
- * @ order    : ln(block_size).
+ * @ kcm      : pointer on KCM manager to initialize.
+ * @ type     : KCM allocator type.
  ***************************************************************************************/
-void kcm_init( kcm_t    * kcm,
-               uint32_t   order );
+error_t kcm_init( kcm_t       * kcm,
+		          uint32_t      type );
 
 /****************************************************************************************
- * This function must be called by a local thread. 
- * It releases all memory allocated to a Kernel Cache Manager.
+ * This function releases all memory allocated to a generic Kernel Cache Manager. 
  ****************************************************************************************
  * @ kcm      : pointer on KCM manager to destroy.
  ***************************************************************************************/
-void kcm_destroy( kcm_t  * kcm );
+void kcm_destroy( kcm_t       * kcm );
 
 /****************************************************************************************
- * This function must be called by a local thread. 
- * It allocates one block from the local Kernel Cache Manager.
+ * This function allocates one single object in a Kernel Cache Manager 
+ * The object size must be smaller than one page size.
  ****************************************************************************************
- * @ order     :  ln( block-size ) == KCM allocator identifier.
- * @ return pointer on allocated block if success / return NULL if failure
+ * @ kcm     :  pointer on the selected KCM allocator
  ***************************************************************************************/
-void * kcm_alloc( uint32_t order );
+void * kcm_alloc( kcm_t * kcm );
 
 /****************************************************************************************
- * This function must be called by a local thread. 
- * It releases a previouly allocated block to the local Kernel Cache Manager.
+ * This function releases a previouly allocated block containing one object.
  ****************************************************************************************
- * @ block_ptr   : local pointer on the released block.
- * @ order       : log2( block_size in bytes ).
+ * @ ptr   : local pointer on the allocated buffer.
  ***************************************************************************************/
-void kcm_free( void    * block_ptr,
-               uint32_t  order );
+void  kcm_free( void * ptr );
+
+/****************************************************************************************
+ * This function prints KCM allocator state (for debug only).
+ ****************************************************************************************
+ * @ kcm   : local pointer on the selected KCM allocator.
+ ***************************************************************************************/
+void kcm_print( kcm_t * kcm );
 
 
 
-
-/****************************************************************************************
- * This function can be called by any thread running in any cluster. 
- * It allocates one fixed size block from a remote Kernel Cache Manager.
- ****************************************************************************************
- * @ kcm_cxy   : remote KCM cluster identifier.
- * @ order     :  ln( block-size ) == KCM allocator identifier.
- * @ return a local pointer on allocated block if success / return NULL if failure
- ***************************************************************************************/
-void * kcm_remote_alloc( cxy_t    kcm_cxy,
-                         uint32_t order );
-
-/****************************************************************************************
- * This function can be called by any thread running in any cluster. 
- * It releases a previouly allocated block to a remote Kernel Cache Manager.
- ****************************************************************************************
- * @ kcm_cxy     : remote KCM cluster identifier.
- * @ block_ptr   : local pointer on the released buffer in remote cluster.
- * @ order       : log2( block_size in bytes ).
- ***************************************************************************************/
-void kcm_remote_free( cxy_t     kcm_cxy,
-                      void    * block_ptr,
-                      uint32_t  order );
-
-/****************************************************************************************
- * This debug function can be called by any thread running in any cluster. It displays
- * on TXT0 the state of a KCM, identified by the <kcm_cxy> & <kcm_ptr> arguments.
- ****************************************************************************************
- * @ kcm_cxy : remote KCM cluster identifier.
- * @ kcm_ptr : local pointer on remote KCM.
- ***************************************************************************************/
-void kcm_remote_display( cxy_t   kcm_cxy,
-                         kcm_t * kcm_ptr );
-
 #endif	/* _KCM_H_ */
Index: trunk/kernel/mm/khm.c
===================================================================
--- trunk/kernel/mm/khm.c	(revision 690)
+++ trunk/kernel/mm/khm.c	(revision 1)
@@ -1,7 +1,7 @@
 /*
- * khm.c - Kernel Heap Manager implementation.
- *
+ * khm.c - kernel heap manager implementation.
+ * 
  * Authors  Ghassan Almaless (2008,2009,2010,2011,2012)
- *          Alain Greiner (2016,2017,2018)
+ *          Alain Greiner (2016)
  *
  * Copyright (c)  UPMC Sorbonne Universites
@@ -23,8 +23,8 @@
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
+#include <almos_config.h>
+#include <hal_types.h>
 #include <hal_special.h>
-#include <busylock.h>
+#include <spinlock.h>
 #include <bits.h>
 #include <printk.h>
@@ -39,25 +39,27 @@
 void khm_init( khm_t * khm )
 {
-	// check config parameters
-	assert( __FUNCTION__, ((CONFIG_PPM_PAGE_ORDER + CONFIG_PPM_HEAP_ORDER) < 32 ) ,
-	         "CONFIG_PPM_HEAP_ORDER too large" );
+    // check config parameters
+    if( (CONFIG_PPM_PAGE_SHIFT + CONFIG_PPM_HEAP_ORDER) >= 32 )
+    {
+        printk("\n[PANIC] in %s : CONFIG_PPM_HEAP_ORDER too large\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
 
-	// initialize lock
-	busylock_init( &khm->lock , LOCK_KHM_STATE );
+    // initialize lock
+	spinlock_init( &khm->lock );  
+    
+    //  compute kernel heap size 
+    intptr_t heap_size = (1 << CONFIG_PPM_HEAP_ORDER) << CONFIG_PPM_PAGE_SHIFT;
 
-	// compute kernel heap size
-	intptr_t heap_size = (1 << CONFIG_PPM_HEAP_ORDER) << CONFIG_PPM_PAGE_ORDER;
+    // get kernel heap base from PPM 
+    page_t * page      = ppm_alloc_pages( CONFIG_PPM_HEAP_ORDER );
+    void   * heap_base = ppm_page2base( page );
 
-	// get kernel heap base from PPM
-	page_t * page      = ppm_alloc_pages( CONFIG_PPM_HEAP_ORDER );
-	xptr_t   base_xp   = ppm_page2base( XPTR( local_cxy, page ) );
-	void   * heap_base = GET_PTR( base_xp );
-
-	// initialize first block (complete heap)
+    // initializes first block == complete heap
 	khm_block_t * block = (khm_block_t *)heap_base;
 	block->size = heap_size;
 	block->busy = 0;
 
-	// initialize KHM fields
+    // initializes KHM fields
 	khm->base    = (intptr_t)heap_base;
 	khm->size    = heap_size;
@@ -66,33 +68,33 @@
 
 /////////////////////////////////
-void * khm_alloc( khm_t    * khm,
+void * khm_alloc( khm_t    * khm, 
                   uint32_t   size )
 {
-	khm_block_t  * current;
+	khm_block_t  * current;        
 	khm_block_t  * next;
 	uint32_t       effective_size;
 
-	// compute actual block size
+    // compute actual block size
 	effective_size = size + sizeof(khm_block_t);
 	effective_size = ARROUND_UP( effective_size, CONFIG_CACHE_LINE_SIZE );
 
-	// get lock protecting heap
-	busylock_acquire( &khm->lock );
+    // get lock protecting heap
+	spinlock_lock( &khm->lock );
+  
+    // define a starting block to scan existing blocks 
+    if( ((khm_block_t*)khm->next)->size < effective_size ) current = (khm_block_t*)khm->base;
+    else                                                   current = (khm_block_t*)khm->next;
 
-	// define a starting block to scan existing blocks
-	if( ((khm_block_t*)khm->next)->size < effective_size ) current = (khm_block_t*)khm->base;
-	else                                                   current = (khm_block_t*)khm->next;
-
-	// scan all existing blocks to find a free block large enough
-	while( current->busy || (current->size < effective_size))
+    // scan all existing blocks to find a large enough free block
+	while( current->busy || (current->size < effective_size)) 
 	{
-		// get next block pointer
+        // get next block pointer
 		current = (khm_block_t*)((char*)current + current->size);
-
+    
 		if( (intptr_t)current >= (khm->base + khm->size) )  // heap full
 		{
-			busylock_release(&khm->lock);
+			spinlock_unlock(&khm->lock);
 
-			printk("\n[ERROR] in %s : failed to allocate block of size %d\n",
+			printk("\n[ERROR] in %s : failed to allocate block of size %d\n", 
 			       __FUNCTION__ , effective_size );
 			return NULL;
@@ -100,27 +102,27 @@
 	}
 
-	// split the current block if it is too large
+    // split the current block if current block is too large
 	if( (current->size - effective_size) >= CONFIG_CACHE_LINE_SIZE )
 	{
-		// update new free block features
+        // update new free block features
 		next           = (khm_block_t *)((char*)current + effective_size);
 		next->size     = current->size - effective_size;
 		next->busy     = 0;
 
-		// register new free block
+        // register new free block
 		khm->next = (intptr_t)next;
 
-		// update allocated block features
+        // update allocated block features
 		current->size  = effective_size;
 		current->busy  = 1;
 	}
 	else
-	{
-		// change block state
+    {
+        // change block state
 		current->busy  = 1;
-	}
+    }
 
-	// release lock protecting heap
-	busylock_release( &khm->lock );
+    // release lock protecting heap
+	spinlock_unlock( &khm->lock );
 
 	return (char*)current + sizeof(khm_block_t);
@@ -134,21 +136,19 @@
 	khm_block_t * current;
 	khm_block_t * next;
+  
+	if(ptr == NULL) return;
+  
+	current = (khm_block_t *)((char*)ptr - sizeof(khm_block_t));
+ 
+    // get lock protecting heap
+	spinlock_lock(&khm->lock);
 
-	if(ptr == NULL) return;
-
-	current = (khm_block_t *)((char*)ptr - sizeof(khm_block_t));
-
-	// get lock protecting heap
-	busylock_acquire(&khm->lock);
-
-	assert( __FUNCTION__, (current->busy == 1) , "page already freed" );
-
-	// release block
+    // release block 
 	current->busy = 0;
-
-	// try to merge released block with the next
+  
+    // try to merge released block with the next
 	while ( 1 )
-	{
-		next = (khm_block_t*)((char*)current + current->size);
+	{ 
+        next = (khm_block_t*)((char*)current + current->size);
 		if ( ((intptr_t)next >= (khm->base + khm->size)) || (next->busy == 1) ) break;
 		current->size += next->size;
@@ -156,7 +156,7 @@
 
 	if( (intptr_t)current < khm->next ) khm->next = (intptr_t)current;
-
-	// release lock protecting heap
-	busylock_release( &khm->lock );
+  
+    // release lock protecting heap
+	spinlock_unlock( &khm->lock );
 }
 
Index: trunk/kernel/mm/khm.h
===================================================================
--- trunk/kernel/mm/khm.h	(revision 690)
+++ trunk/kernel/mm/khm.h	(revision 1)
@@ -1,7 +1,8 @@
 /*
- * khm.h - Kernel Heap Manager definition.
- *
+ * khm.h - kernel heap manager used for variable size memory allocation.
+ * 
  * Authors  Ghassan Almaless (2008,2009,2010,2011,2012)
- *          Alain Greiner (2016,2017,2018,2019)
+ *          Mohamed Lamine Karaoui (2015)
+ *          Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -26,17 +27,17 @@
 #define _HEAP_MANAGER_H_
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <busylock.h>
+#include <almos_config.h>
+#include <hal_types.h>
+#include <spinlock.h>
 
 /*******************************************************************************************
  * This structure defines a Kernel Heap Manager (KHM) in a given cluster.
- * It is used to allocate memory objects, that are too large, or not enough replicated
- * to use a dedicated KCM allocator.
+ * It is used to allocate memory objects, that are not 
+ * enough replicated to justify a dedicated KCM allocator.
  ******************************************************************************************/
 
 typedef struct khm_s
 {
-	busylock_t lock;           /*! lock protecting KHM allocator                          */
+	spinlock_t lock;           /*! lock protecting exclusive access to heap               */
 	intptr_t   base;           /*! heap base address                                      */
 	uint32_t   size;           /*! heap size (bytes)                                      */
@@ -47,5 +48,5 @@
 /*******************************************************************************************
  * This structure defines an allocated block descriptor for the KHM.
- * This block descriptor is stored at the beginning of the allocated block.
+ * This block descriptor is stored at the beginning of the allocated block. 
  * The returned pointer is the allocated memory block base + block descriptor size.
  ******************************************************************************************/
@@ -53,7 +54,7 @@
 typedef struct khm_block_s
 {
-	uint32_t   busy;           /*! free block if zero                                     */
-	uint32_t   size;           /*! block size                                             */
-}
+	uint32_t   busy:1;         /*! free block if zero                                     */
+	uint32_t   size:31;        /*! size coded on 31 bits                                  */
+} 
 khm_block_t;
 
@@ -61,5 +62,5 @@
 /*******************************************************************************************
  * This function initializes a KHM heap manager in a given cluster.
- * It is used to allocate variable size memory objects, that are not
+ * It is used to allocate variable size memory objects, that are not 
  * enough replicated to justify a dedicated KCM allocator.
  *******************************************************************************************
@@ -71,5 +72,5 @@
 
 /*******************************************************************************************
- * This function allocates a memory block from the local KHM.
+ * This function allocates a memory block from the local KHM. 
  * The actual size of the allocated block is the requested size, plus the block descriptor
  * size, rounded to a cache line size.
